unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, OleCtrls, AxRemoteProj1_TLB,mmsystem, Buttons;

type
  TfrmMain = class(TForm)
    AxRemote1: TAxRemote;
    btnDevSet: TButton;
    GroupBox1: TGroupBox;
    chkShowTitle: TCheckBox;
    chkShowStatus: TCheckBox;
    chkShowToolbar: TCheckBox;
    chkOSDName: TCheckBox;
    chkOSDTime: TCheckBox;
    GroupBox2: TGroupBox;
    btnConnect: TButton;
    btnDisconnect: TButton;
    edID: TEdit;
    edAcc: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    edPwd: TEdit;
    Label3: TLabel;
    chkShowFPS: TCheckBox;
    chkShowRate: TCheckBox;
    Label4: TLabel;
    btnStartRec: TButton;
    btnStopRec: TButton;
    btnCapture: TButton;
    btnCaptureTool: TButton;
    btnNetSet: TButton;
    chkTurnImg: TCheckBox;
    chkCanPopupMenu: TCheckBox;
    cmbDevType: TComboBox;
    Label5: TLabel;
    chkAlarm: TCheckBox;
    btnStartTalk: TButton;
    btnStopTalk: TButton;
    spbLeft: TSpeedButton;
    spbDown: TSpeedButton;
    spbUp: TSpeedButton;
    spbRight: TSpeedButton;
    spbHScan: TSpeedButton;
    spbVScan: TSpeedButton;
    cmbPos: TComboBox;
    spbSetPos: TSpeedButton;
    spbCallPos: TSpeedButton;
    spbShowSD: TSpeedButton;
    Label6: TLabel;
    procedure btnConnectClick(Sender: TObject);
    procedure btnDevSetClick(Sender: TObject);
    procedure chkShowTitleClick(Sender: TObject);
    procedure chkShowStatusClick(Sender: TObject);
    procedure chkShowToolbarClick(Sender: TObject);
    procedure chkOSDNameClick(Sender: TObject);
    procedure chkOSDTimeClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btnDisconnectClick(Sender: TObject);
    procedure chkShowRateClick(Sender: TObject);
    procedure chkShowFPSClick(Sender: TObject);
    procedure btnStartRecClick(Sender: TObject);
    procedure btnStopRecClick(Sender: TObject);
    procedure btnCaptureClick(Sender: TObject);
    procedure btnCaptureToolClick(Sender: TObject);
    procedure btnNetSetClick(Sender: TObject);
    procedure chkTurnImgClick(Sender: TObject);
    procedure chkCanPopupMenuClick(Sender: TObject);
    procedure AxRemote1Alarm(ASender: TObject; bStart: Integer);
    procedure chkAlarmClick(Sender: TObject);
    procedure AxRemote1Click(Sender: TObject);
    procedure AxRemote1MouseDown(ASender: TObject; Button, X, Y: Integer);
    procedure AxRemote1MouseUp(ASender: TObject; Button, X, Y: Integer);
    procedure AxRemote1VideoConnected(ASender: TObject; BmpInfo,
      AudioFmt: Integer);
    procedure AxRemote1VideoDisconnect(Sender: TObject);
    procedure AxRemote1VideoSample(ASender: TObject; nFrameID, IsVideo,
      pData, nDataLen: Integer);
    procedure btnStartTalkClick(Sender: TObject);
    procedure btnStopTalkClick(Sender: TObject);
    procedure spbLeftMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure spbDownMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure spbHScanClick(Sender: TObject);
    procedure spbVScanClick(Sender: TObject);
    procedure AxRemote1PreVideoSample(ASender: TObject; nFrameID: Integer;
      var bDecode, bShow: Integer; pData, nDataLen: Integer);
    procedure spbSetPosClick(Sender: TObject);
    procedure spbCallPosClick(Sender: TObject);
    procedure spbShowSDClick(Sender: TObject);
    procedure AxRemote1UnVideoSample(ASender: TObject; nFrameID, BufSrc,
      nBufLen, bKey: Integer; tTime: Double);
    procedure AxRemote1GetSDFileCallBack(ASender: TObject;
      const szFileName, nFileDate: WideString; nFileLen, nRecNum: Integer);
  private
    m_Bmp:TBitmapInfoHeader;
    m_Audio:TWaveFormatEx;
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation
{$R *.dfm}

procedure TfrmMain.btnConnectClick(Sender: TObject);
var nDevType:integer;
begin
    AxRemote1.Proxy := 'user.ipcam.so'; // 'user.9556.org';///
    if(cmbDevType.ItemIndex = 0)then
        nDevType := 901
    else if(cmbDevType.ItemIndex = 1)then
        nDevType := 903
    else if(cmbDevType.ItemIndex = 2)then
        nDevType := 902
    else if(cmbDevType.ItemIndex = 3)then
        nDevType := 906
    else if(cmbDevType.ItemIndex = 4)then
        nDevType := 912
    else if(cmbDevType.ItemIndex = 5)then
        nDevType := 918
    else if(cmbDevType.ItemIndex = 6)then
        nDevType := 924
    else if(cmbDevType.ItemIndex = 7)then
        nDevType := 922;


    AxRemote1.Selected := 1;
		AxRemote1.Lan := 'en';
		AxRemote1.ShowOSDName := 1;
		AxRemote1.SwitchLayout('1 x 1');
		AxRemote1.Width:=320;
		AxRemote1.Height:=260;

		AxRemote1.ShowToolBar := 0;
    AxRemote1.AddDev4(nDevType,1,Trim(edID.Text),0,
        'Camera',Trim(edAcc.Text),Trim(edPwd.Text),1);
    AxRemote1.Listen := 1;
    AxRemote1.TCPMode := 2;
    AxRemote1.VideoRate := 1;
    if(chkAlarm.Checked)then
        AxRemote1.EnableAlarm := 1
    else
        AxRemote1.EnableAlarm := 0;
    AxRemote1.ConnectAll();
end;

procedure TfrmMain.btnDevSetClick(Sender: TObject);
begin
    AxRemote1.DevSet;
end;

procedure TfrmMain.chkShowTitleClick(Sender: TObject);
begin
    if(chkShowTitle.Checked)then
        AxRemote1.ShowTitle := 1
    else
        AxRemote1.ShowTitle := 0;
end;

procedure TfrmMain.chkShowStatusClick(Sender: TObject);
begin
    if(chkShowStatus.Checked)then
        AxRemote1.ShowStatus := 1
    else
        AxRemote1.ShowStatus := 0;
end;

procedure TfrmMain.chkShowToolbarClick(Sender: TObject);
begin
    if(chkShowToolbar.checked)then
        AxRemote1.ShowToolBar := 1
    else
        AxRemote1.ShowToolBar := 0;
end;

procedure TfrmMain.chkOSDNameClick(Sender: TObject);
begin
    if(chkOSDName.Checked)then
        AxRemote1.ShowOSDName := 1
    else
        AxRemote1.ShowOSDName := 0;
end;

procedure TfrmMain.chkOSDTimeClick(Sender: TObject);
begin
    if(chkOSDTime.Checked)then
        AxRemote1.ShowOSDTime := 1
    else
        AxRemote1.ShowOSDTime := 0;
end;

procedure TfrmMain.FormCreate(Sender: TObject);
begin
    Label4.Caption := 'Axtive Verion:' + AxRemote1.Ver;
    chkShowTitle.Checked := AxRemote1.ShowTitle <> 0;
    chkShowStatus.Checked := AxRemote1.ShowStatus <> 0;
    chkShowToolBar.Checked := AxRemote1.ShowToolBar <> 0;
    chkOSDName.Checked := AxRemote1.ShowOSDName <> 0;
    chkOSDTime.Checked := AxRemote1.ShowOSDTime <> 0;
    chkShowFPS.Checked := AxRemote1.ShowFPS <> 0;
    chkShowRate.Checked := AxRemote1.ShowRate <> 0;
    chkCanPopupMenu.Checked := AxRemote1.CanPopupMenu <> 0;
end;

procedure TfrmMain.btnDisconnectClick(Sender: TObject);
begin
    AxRemote1.DisConnectAll;
end;

procedure TfrmMain.chkShowRateClick(Sender: TObject);
begin
    if(chkShowRate.Checked)then
        AxRemote1.ShowRate := 1
    else
        AxRemote1.ShowRate := 0;
end;

procedure TfrmMain.chkShowFPSClick(Sender: TObject);
begin
    if(chkShowFPS.Checked)then
        AxRemote1.ShowFPS := 1
    else
        AxRemote1.ShowFPS := 0;
end;

procedure TfrmMain.btnStartRecClick(Sender: TObject);
var nRe:integer;
begin
    if(AxRemote1.IsRecing <> 0)then
        Exit;
    nRe := AxRemote1.StartRec('c:\a.avi');
    if(nRe <> 0)then
        ShowMessage('Record error::' + IntToStr(nRe))
    else
        ShowMessage('Record file is saved to c:\a.avi');
end;

procedure TfrmMain.btnStopRecClick(Sender: TObject);
begin
    if(AxRemote1.IsRecing <> 0)then
        AxRemote1.StopRec;
end;

procedure TfrmMain.btnCaptureClick(Sender: TObject);
var nRe:integer;
begin
    nRe := AxRemote1.Capture('c:\a.bmp');
    if(nRe <> 0)then
        ShowMessage('Snapshot Error:' + IntToStr(nRe))
    else
        ShowMessage('Picture saved to c:\a.bmp');
end;

procedure TfrmMain.btnCaptureToolClick(Sender: TObject);
begin
    AxRemote1.CaptureTool;
end;

procedure TfrmMain.btnNetSetClick(Sender: TObject);
begin
    AxRemote1.NetSet;
end;

procedure TfrmMain.chkTurnImgClick(Sender: TObject);
begin
    if(chkTurnImg.Checked)then
        AxRemote1.TurnImg := 1
    else
        AxRemote1.TurnImg := 0;
end;

procedure TfrmMain.chkCanPopupMenuClick(Sender: TObject);
begin
    if(chkCanPopupMenu.Checked)then
        AxRemote1.CanPopupMenu := 1
    else
        AxRemote1.CanPopupMenu := 0;
end;

procedure TfrmMain.AxRemote1Alarm(ASender: TObject; bStart: Integer);
begin
    if(bStart = 0)then
        ShowMessage('Alarm End')
    else
        ShowMessage('Alarm Start');
end;

procedure TfrmMain.chkAlarmClick(Sender: TObject);
begin
    if(chkAlarm.Checked)then
        AxRemote1.EnableAlarm := 1
    else
        AxRemote1.EnableAlarm := 0;
end;

procedure TfrmMain.AxRemote1Click(Sender: TObject);
begin
Sleep(0);
end;

procedure TfrmMain.AxRemote1MouseDown(ASender: TObject; Button, X,
  Y: Integer);
begin
Sleep(0);
end;

procedure TfrmMain.AxRemote1MouseUp(ASender: TObject; Button, X,
  Y: Integer);
begin
sleep(0);
end;

procedure TfrmMain.AxRemote1VideoConnected(ASender: TObject; BmpInfo,
  AudioFmt: Integer);
begin
    m_Bmp := PBitmapInfoHeader(BmpInfo)^;
    m_Audio := PWaveFormatEx(AudioFmt)^;
end;

procedure TfrmMain.AxRemote1VideoDisconnect(Sender: TObject);
begin
;
end;

procedure TfrmMain.AxRemote1VideoSample(ASender: TObject; nFrameID,
  IsVideo, pData, nDataLen: Integer);
    function    MakeBmp(pData:PBYTE;pBmpInfo:PBitmapInfoHeader):TBitmap;
    var p:Pointer;
        bmpInfo:TBitmapInfo;
    begin
        Result := nil;
        if(pData = nil) or (pBmpInfo = nil)then
            Exit;
        try
            Result := TBitmap.Create;
            bmpInfo.bmiHeader := pBmpInfo^;
            Result.Handle := CreateDIBSection(0, BmpInfo,DIB_RGB_COLORS, p, 0, 0);
            if(p <> nil)then
                CopyMemory(p,pData,pBmpInfo.biSizeImage);
        except
            Result.Free;
            Result := nil;
        end;
    end;
var bmp:TBitmap;
    p:PByte;
begin
{
    if(IsVideo)then begin
        p := PBYTE(pData);
        bmp := MakeBmp(p,@m_Bmp);
        bmp.SaveToFile('f:\a.bmp');
        bmp.Free;
    end;
    }
end;

procedure TfrmMain.btnStartTalkClick(Sender: TObject);
begin
    AxRemote1.StartTalk;
end;

procedure TfrmMain.btnStopTalkClick(Sender: TObject);
begin
    AxRemote1.StopTalk;
end;

procedure TfrmMain.spbLeftMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var nAction :integer;
begin
    nAction := TComponent(Sender).Tag;
    AxRemote1.PTZ(1,1,nAction,1,1,0);
end;

procedure TfrmMain.spbDownMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
    AxRemote1.PTZ(1,1,-1,1,1,0);
end;

procedure TfrmMain.spbHScanClick(Sender: TObject);
begin
    if(TComponent(Sender).tag = 0)then begin
        AxRemote1.PTZ(1,1,8,0,0,0);
        TComponent(Sender).tag := 1;
    end
    else begin
        AxRemote1.PTZ(1,1,9,0,0,0);
        TComponent(Sender).tag := 0;
    end;
end;

procedure TfrmMain.spbVScanClick(Sender: TObject);
begin
    if(TComponent(Sender).tag = 0)then begin
        AxRemote1.PTZ(1,1,21,0,0,0);
        TComponent(Sender).tag := 1;
    end
    else begin
        AxRemote1.PTZ(1,1,22,0,0,0);
        TComponent(Sender).tag := 0;
    end;
end;

procedure TfrmMain.AxRemote1PreVideoSample(ASender: TObject;
  nFrameID: Integer; var bDecode, bShow: Integer; pData,
  nDataLen: Integer);
begin
;
end;

procedure TfrmMain.spbSetPosClick(Sender: TObject);
var nPos:integer;
begin
    nPos := cmbPos.ItemIndex + 1;
    AxRemote1.PTZ(1, 1, 15, 1, nPos, 0);  
end;

procedure TfrmMain.spbCallPosClick(Sender: TObject);
var nPos:integer;
begin
    nPos := cmbPos.ItemIndex + 1;
    AxRemote1.PTZ(1, 1, 14, 1, nPos, 0);
end;

procedure TfrmMain.spbShowSDClick(Sender: TObject);
begin
    AxRemote1.SDPlay(922,'',Trim(edID.Text),'',Trim(edPwd.Text),1);
end;

procedure TfrmMain.AxRemote1UnVideoSample(ASender: TObject; nFrameID,
  BufSrc, nBufLen, bKey: Integer; tTime: Double);
begin
;
end;

procedure TfrmMain.AxRemote1GetSDFileCallBack(ASender: TObject;
  const szFileName, nFileDate: WideString; nFileLen, nRecNum: Integer);
begin
    Label6.Caption := szFileName;
end;

end.
